Gentoo Archives: gentoo-commits

From: "Robin H. Johnson (robbat2)" <robbat2@g.o>
To: gentoo-commits@l.g.o
Subject: [gentoo-commits] gentoo-x86 commit in dev-vcs/git: git-1.8.4.2.ebuild ChangeLog
Date: Mon, 28 Oct 2013 19:28:14
Message-Id: 20131028192806.DC62E20047@flycatcher.gentoo.org
1 robbat2 13/10/28 19:28:06
2
3 Modified: ChangeLog
4 Added: git-1.8.4.2.ebuild
5 Log:
6 Bump.
7
8 (Portage version: 2.2.0_alpha177/cvs/Linux x86_64, unsigned Manifest commit)
9
10 Revision Changes Path
11 1.219 dev-vcs/git/ChangeLog
12
13 file : http://sources.gentoo.org/viewvc.cgi/gentoo-x86/dev-vcs/git/ChangeLog?rev=1.219&view=markup
14 plain: http://sources.gentoo.org/viewvc.cgi/gentoo-x86/dev-vcs/git/ChangeLog?rev=1.219&content-type=text/plain
15 diff : http://sources.gentoo.org/viewvc.cgi/gentoo-x86/dev-vcs/git/ChangeLog?r1=1.218&r2=1.219
16
17 Index: ChangeLog
18 ===================================================================
19 RCS file: /var/cvsroot/gentoo-x86/dev-vcs/git/ChangeLog,v
20 retrieving revision 1.218
21 retrieving revision 1.219
22 diff -p -w -b -B -u -u -r1.218 -r1.219
23 --- ChangeLog 20 Oct 2013 20:11:50 -0000 1.218
24 +++ ChangeLog 28 Oct 2013 19:28:06 -0000 1.219
25 @@ -1,6 +1,11 @@
26 # ChangeLog for dev-vcs/git
27 # Copyright 1999-2013 Gentoo Foundation; Distributed under the GPL v2
28 -# $Header: /var/cvsroot/gentoo-x86/dev-vcs/git/ChangeLog,v 1.218 2013/10/20 20:11:50 grobian Exp $
29 +# $Header: /var/cvsroot/gentoo-x86/dev-vcs/git/ChangeLog,v 1.219 2013/10/28 19:28:06 robbat2 Exp $
30 +
31 +*git-1.8.4.2 (28 Oct 2013)
32 +
33 + 28 Oct 2013; Robin H. Johnson <robbat2@g.o> +git-1.8.4.2.ebuild:
34 + Bump.
35
36 20 Oct 2013; Fabian Groffen <grobian@g.o> git-1.8.4.ebuild,
37 git-9999.ebuild:
38
39
40
41 1.1 dev-vcs/git/git-1.8.4.2.ebuild
42
43 file : http://sources.gentoo.org/viewvc.cgi/gentoo-x86/dev-vcs/git/git-1.8.4.2.ebuild?rev=1.1&view=markup
44 plain: http://sources.gentoo.org/viewvc.cgi/gentoo-x86/dev-vcs/git/git-1.8.4.2.ebuild?rev=1.1&content-type=text/plain
45
46 Index: git-1.8.4.2.ebuild
47 ===================================================================
48 # Copyright 1999-2013 Gentoo Foundation
49 # Distributed under the terms of the GNU General Public License v2
50 # $Header: /var/cvsroot/gentoo-x86/dev-vcs/git/git-1.8.4.2.ebuild,v 1.1 2013/10/28 19:28:06 robbat2 Exp $
51
52 EAPI=5
53
54 GENTOO_DEPEND_ON_PERL=no
55
56 # bug #329479: git-remote-testgit is not multiple-version aware
57 PYTHON_COMPAT=( python2_{6,7} )
58 [[ ${PV} == *9999 ]] && SCM="git-2"
59 EGIT_REPO_URI="git://git.kernel.org/pub/scm/git/git.git"
60
61 inherit toolchain-funcs eutils elisp-common perl-module bash-completion-r1 python-single-r1 systemd ${SCM}
62
63 MY_PV="${PV/_rc/.rc}"
64 MY_P="${PN}-${MY_PV}"
65
66 DOC_VER=${MY_PV}
67
68 DESCRIPTION="GIT - the stupid content tracker, the revision control system heavily used by the Linux kernel team"
69 HOMEPAGE="http://www.git-scm.com/"
70 if [[ ${PV} != *9999 ]]; then
71 SRC_URI_SUFFIX="gz"
72 SRC_URI_GOOG="http://git-core.googlecode.com/files"
73 SRC_URI_KORG="mirror://kernel/software/scm/git"
74 SRC_URI="${SRC_URI_GOOG}/${MY_P}.tar.${SRC_URI_SUFFIX}
75 ${SRC_URI_KORG}/${MY_P}.tar.${SRC_URI_SUFFIX}
76 ${SRC_URI_GOOG}/${PN}-manpages-${DOC_VER}.tar.${SRC_URI_SUFFIX}
77 ${SRC_URI_KORG}/${PN}-manpages-${DOC_VER}.tar.${SRC_URI_SUFFIX}
78 doc? (
79 ${SRC_URI_KORG}/${PN}-htmldocs-${DOC_VER}.tar.${SRC_URI_SUFFIX}
80 ${SRC_URI_GOOG}/${PN}-htmldocs-${DOC_VER}.tar.${SRC_URI_SUFFIX}
81 )"
82 KEYWORDS="~alpha ~amd64 ~arm ~hppa ~ia64 ~mips ~ppc ~ppc64 ~s390 ~sh ~sparc ~x86 ~ppc-aix ~amd64-fbsd ~sparc-fbsd ~x86-fbsd ~x64-freebsd ~x86-freebsd ~ia64-hpux ~x86-interix ~amd64-linux ~arm-linux ~ia64-linux ~x86-linux ~ppc-macos ~x64-macos ~x86-macos ~sparc-solaris ~sparc64-solaris ~x64-solaris ~x86-solaris"
83 else
84 SRC_URI=""
85 KEYWORDS=""
86 fi
87
88 LICENSE="GPL-2"
89 SLOT="0"
90 IUSE="+blksha1 +curl cgi doc emacs gnome-keyring +gpg gtk highlight +iconv +nls +pcre +perl +python ppcsha1 tk +threads +webdav xinetd cvs subversion test"
91
92 # Common to both DEPEND and RDEPEND
93 CDEPEND="
94 dev-libs/openssl
95 sys-libs/zlib
96 pcre? ( dev-libs/libpcre )
97 perl? ( dev-lang/perl[-build(-)] )
98 tk? ( dev-lang/tk )
99 curl? (
100 net-misc/curl
101 webdav? ( dev-libs/expat )
102 )
103 emacs? ( virtual/emacs )
104 gnome-keyring? ( gnome-base/gnome-keyring )"
105
106 RDEPEND="${CDEPEND}
107 gpg? ( app-crypt/gnupg )
108 perl? ( dev-perl/Error
109 dev-perl/Net-SMTP-SSL
110 dev-perl/Authen-SASL
111 cgi? ( virtual/perl-CGI highlight? ( app-text/highlight ) )
112 cvs? ( >=dev-vcs/cvsps-2.1 dev-perl/DBI dev-perl/DBD-SQLite )
113 subversion? ( dev-vcs/subversion[-dso,perl] dev-perl/libwww-perl dev-perl/TermReadKey )
114 )
115 python? ( gtk?
116 (
117 >=dev-python/pygtk-2.8[${PYTHON_USEDEP}]
118 >=dev-python/pygtksourceview-2.10.1-r1:2[${PYTHON_USEDEP}]
119 )
120 ${PYTHON_DEPS} )"
121
122 # This is how info docs are created with Git:
123 # .txt/asciidoc --(asciidoc)---------> .xml/docbook
124 # .xml/docbook --(docbook2texi.pl)--> .texi
125 # .texi --(makeinfo)---------> .info
126 DEPEND="${CDEPEND}
127 app-arch/cpio
128 doc? (
129 app-text/asciidoc
130 app-text/docbook2X
131 sys-apps/texinfo
132 app-text/xmlto
133 )
134 test? (
135 app-crypt/gnupg
136 )"
137
138 # Live ebuild builds man pages and HTML docs, additionally
139 if [[ ${PV} == *9999 ]]; then
140 DEPEND="${DEPEND}
141 app-text/asciidoc"
142 fi
143
144 SITEFILE=50${PN}-gentoo.el
145 S="${WORKDIR}/${MY_P}"
146
147 REQUIRED_USE="
148 cgi? ( perl )
149 cvs? ( perl )
150 subversion? ( perl )
151 webdav? ( curl )
152 gtk? ( python )
153 python? ( ${PYTHON_REQUIRED_USE} )
154 "
155
156 pkg_setup() {
157 if use subversion && has_version "dev-vcs/subversion[dso]"; then
158 ewarn "Per Gentoo bugs #223747, #238586, when subversion is built"
159 ewarn "with USE=dso, there may be weird crashes in git-svn. You"
160 ewarn "have been warned."
161 fi
162 if use python ; then
163 python-single-r1_pkg_setup
164 fi
165 }
166
167 # This is needed because for some obscure reasons future calls to make don't
168 # pick up these exports if we export them in src_unpack()
169 exportmakeopts() {
170 local myopts
171
172 if use blksha1 ; then
173 myopts="${myopts} BLK_SHA1=YesPlease"
174 elif use ppcsha1 ; then
175 myopts="${myopts} PPC_SHA1=YesPlease"
176 fi
177
178 if use curl ; then
179 use webdav || myopts="${myopts} NO_EXPAT=YesPlease"
180 else
181 myopts="${myopts} NO_CURL=YesPlease"
182 fi
183
184 # broken assumptions, because of broken build system ...
185 myopts="${myopts} NO_FINK=YesPlease NO_DARWIN_PORTS=YesPlease"
186 myopts="${myopts} INSTALL=install TAR=tar"
187 myopts="${myopts} SHELL_PATH=${EPREFIX}/bin/sh"
188 myopts="${myopts} SANE_TOOL_PATH="
189 myopts="${myopts} OLD_ICONV="
190 myopts="${myopts} NO_EXTERNAL_GREP="
191
192 # For svn-fe
193 extlibs="-lz -lssl ${S}/xdiff/lib.a $(usex threads -lpthread '')"
194
195 # can't define this to null, since the entire makefile depends on it
196 sed -i -e '/\/usr\/local/s/BASIC_/#BASIC_/' Makefile
197
198 use iconv \
199 || myopts="${myopts} NO_ICONV=YesPlease"
200 use nls \
201 || myopts="${myopts} NO_GETTEXT=YesPlease"
202 use tk \
203 || myopts="${myopts} NO_TCLTK=YesPlease"
204 use pcre \
205 && myopts="${myopts} USE_LIBPCRE=yes" \
206 && extlibs="${extlibs} -lpcre"
207 use perl \
208 && myopts="${myopts} INSTALLDIRS=vendor" \
209 || myopts="${myopts} NO_PERL=YesPlease"
210 use python \
211 || myopts="${myopts} NO_PYTHON=YesPlease"
212 use subversion \
213 || myopts="${myopts} NO_SVN_TESTS=YesPlease"
214 use threads \
215 && myopts="${myopts} THREADED_DELTA_SEARCH=YesPlease" \
216 || myopts="${myopts} NO_PTHREADS=YesPlease"
217 use cvs \
218 || myopts="${myopts} NO_CVS=YesPlease"
219 # Disabled until ~m68k-mint can be keyworded again
220 # if [[ ${CHOST} == *-mint* ]] ; then
221 # myopts="${myopts} NO_MMAP=YesPlease"
222 # myopts="${myopts} NO_IPV6=YesPlease"
223 # myopts="${myopts} NO_STRLCPY=YesPlease"
224 # myopts="${myopts} NO_MEMMEM=YesPlease"
225 # myopts="${myopts} NO_MKDTEMP=YesPlease"
226 # myopts="${myopts} NO_MKSTEMPS=YesPlease"
227 # fi
228 if [[ ${CHOST} == ia64-*-hpux* ]]; then
229 myopts="${myopts} NO_NSEC=YesPlease"
230 fi
231 if [[ ${CHOST} == *-*-aix* ]]; then
232 myopts="${myopts} NO_FNMATCH_CASEFOLD=YesPlease"
233 fi
234 if [[ ${CHOST} == *-solaris* ]]; then
235 myopts="${myopts} NEEDS_LIBICONV=YesPlease"
236 fi
237
238 has_version '>=app-text/asciidoc-8.0' \
239 && myopts="${myopts} ASCIIDOC8=YesPlease"
240 myopts="${myopts} ASCIIDOC_NO_ROFF=YesPlease"
241
242 # Bug 290465:
243 # builtin-fetch-pack.c:816: error: 'struct stat' has no member named 'st_mtim'
244 [[ "${CHOST}" == *-uclibc* ]] && \
245 myopts="${myopts} NO_NSEC=YesPlease"
246
247 export MY_MAKEOPTS="${myopts}"
248 export EXTLIBS="${extlibs}"
249 }
250
251 src_unpack() {
252 if [[ ${PV} != *9999 ]]; then
253 unpack ${MY_P}.tar.${SRC_URI_SUFFIX}
254 cd "${S}"
255 unpack ${PN}-manpages-${DOC_VER}.tar.${SRC_URI_SUFFIX}
256 use doc && \
257 cd "${S}"/Documentation && \
258 unpack ${PN}-htmldocs-${DOC_VER}.tar.${SRC_URI_SUFFIX}
259 cd "${S}"
260 else
261 git-2_src_unpack
262 cd "${S}"
263 #cp "${FILESDIR}"/GIT-VERSION-GEN .
264 fi
265
266 }
267
268 src_prepare() {
269 # bug #350330 - automagic CVS when we don't want it is bad.
270 epatch "${FILESDIR}"/git-1.8.4-optional-cvs.patch
271
272 sed -i \
273 -e 's:^\(CFLAGS[[:space:]]*=\).*$:\1 $(OPTCFLAGS) -Wall:' \
274 -e 's:^\(LDFLAGS[[:space:]]*=\).*$:\1 $(OPTLDFLAGS):' \
275 -e 's:^\(CC[[:space:]]* =\).*$:\1$(OPTCC):' \
276 -e 's:^\(AR[[:space:]]* =\).*$:\1$(OPTAR):' \
277 -e "s:\(PYTHON_PATH[[:space:]]\+=[[:space:]]\+\)\(.*\)$:\1${EPREFIX}\2:" \
278 -e "s:\(PERL_PATH[[:space:]]\+=[[:space:]]\+\)\(.*\)$:\1${EPREFIX}\2:" \
279 Makefile contrib/svn-fe/Makefile || die "sed failed"
280
281 # Never install the private copy of Error.pm (bug #296310)
282 sed -i \
283 -e '/private-Error.pm/s,^,#,' \
284 perl/Makefile.PL
285
286 # Fix docbook2texi command
287 sed -r -i 's/DOCBOOK2X_TEXI[[:space:]]*=[[:space:]]*docbook2x-texi/DOCBOOK2X_TEXI = docbook2texi.pl/' \
288 Documentation/Makefile || die "sed failed"
289
290 # Fix git-subtree missing DESTDIR
291 sed -i \
292 -e '/$(INSTALL)/s/ $(libexecdir)/ $(DESTDIR)$(libexecdir)/g' \
293 -e '/$(INSTALL)/s/ $(man1dir)/ $(DESTDIR)$(man1dir)/g' \
294 contrib/subtree/Makefile
295 }
296
297 git_emake() {
298 # bug #326625: PERL_PATH, PERL_MM_OPT
299 # bug #320647: PYTHON_PATH
300 PYTHON_PATH=""
301 use python && PYTHON_PATH="${PYTHON}"
302 emake ${MY_MAKEOPTS} \
303 DESTDIR="${D}" \
304 OPTCFLAGS="${CFLAGS}" \
305 OPTLDFLAGS="${LDFLAGS}" \
306 OPTCC="$(tc-getCC)" \
307 OPTAR="$(tc-getAR)" \
308 prefix="${EPREFIX}"/usr \
309 htmldir="${EPREFIX}"/usr/share/doc/${PF}/html \
310 sysconfdir="${EPREFIX}"/etc \
311 PYTHON_PATH="${PYTHON_PATH}" \
312 PERL_MM_OPT="" \
313 GIT_TEST_OPTS="--no-color" \
314 V=1 \
315 "$@"
316 # This is the fix for bug #326625, but it also causes breakage, see bug
317 # #352693.
318 # PERL_PATH="${EPREFIX}/usr/bin/env perl" \
319 }
320
321 src_configure() {
322 exportmakeopts
323 }
324
325 src_compile() {
326 if use perl ; then
327 git_emake perl/PM.stamp || die "emake perl/PM.stamp failed"
328 git_emake perl/perl.mak || die "emake perl/perl.mak failed"
329 fi
330 git_emake || die "emake failed"
331
332 if use emacs ; then
333 elisp-compile contrib/emacs/git{,-blame}.el
334 fi
335
336 if use perl && use cgi ; then
337 git_emake \
338 gitweb/gitweb.cgi \
339 || die "emake gitweb/gitweb.cgi failed"
340 fi
341
342 if [[ ${CHOST} == *-darwin* ]]; then
343 cd "${S}"/contrib/credential/osxkeychain || die "cd credential/osxkeychain"
344 git_emake || die "emake credential-osxkeychain"
345 fi
346
347 cd "${S}"/Documentation
348 if [[ ${PV} == *9999 ]] ; then
349 git_emake man \
350 || die "emake man failed"
351 if use doc ; then
352 git_emake info html \
353 || die "emake info html failed"
354 fi
355 else
356 if use doc ; then
357 git_emake info \
358 || die "emake info html failed"
359 fi
360 fi
361
362 if use subversion ; then
363 cd "${S}"/contrib/svn-fe
364 git_emake EXTLIBS="${EXTLIBS}" || die "emake svn-fe failed"
365 if use doc ; then
366 git_emake svn-fe.{1,html} || die "emake svn-fe.1 svn-fe.html failed"
367 fi
368 cd "${S}"
369 fi
370
371 if use gnome-keyring ; then
372 cd "${S}"/contrib/credential/gnome-keyring
373 git_emake || die "emake git-credential-gnome-keyring failed"
374 fi
375
376 cd "${S}"/contrib/subtree
377 git_emake
378 use doc && git_emake doc
379 }
380
381 src_install() {
382 git_emake \
383 install || \
384 die "make install failed"
385
386 if [[ ${CHOST} == *-darwin* ]]; then
387 dobin contrib/credential/osxkeychain/git-credential-osxkeychain
388 fi
389
390 # Depending on the tarball and manual rebuild of the documentation, the
391 # manpages may exist in either OR both of these directories.
392 find man?/*.[157] >/dev/null 2>&1 && doman man?/*.[157]
393 find Documentation/*.[157] >/dev/null 2>&1 && doman Documentation/*.[157]
394
395 dodoc README Documentation/{SubmittingPatches,CodingGuidelines}
396 use doc && dodir /usr/share/doc/${PF}/html
397 for d in / /howto/ /technical/ ; do
398 docinto ${d}
399 dodoc Documentation${d}*.txt
400 use doc && dohtml -p ${d} Documentation${d}*.html
401 done
402 docinto /
403 # Upstream does not ship this pre-built :-(
404 use doc && doinfo Documentation/{git,gitman}.info
405
406 newbashcomp contrib/completion/git-completion.bash ${PN}
407 newbashcomp contrib/completion/git-prompt.sh ${PN}-prompt
408
409 if use emacs ; then
410 elisp-install ${PN} contrib/emacs/git.{el,elc}
411 elisp-install ${PN} contrib/emacs/git-blame.{el,elc}
412 #elisp-install ${PN}/compat contrib/emacs/vc-git.{el,elc}
413 # don't add automatically to the load-path, so the sitefile
414 # can do a conditional loading
415 touch "${ED}${SITELISP}/${PN}/compat/.nosearch"
416 elisp-site-file-install "${FILESDIR}"/${SITEFILE}
417 fi
418
419 if use python && use gtk ; then
420 python_doscript "${S}"/contrib/gitview/gitview
421 dodoc "${S}"/contrib/gitview/gitview.txt
422 fi
423
424 #dobin contrib/fast-import/git-p4 # Moved upstream
425 #dodoc contrib/fast-import/git-p4.txt # Moved upstream
426 newbin contrib/fast-import/import-tars.perl import-tars
427 exeinto /usr/libexec/git-core/
428 newexe contrib/git-resurrect.sh git-resurrect
429
430 # git-subtree
431 cd "${S}"/contrib/subtree
432 git_emake install || die "Failed to emake install git-subtree"
433 if use doc ; then
434 git_emake install-man install-doc || die "Failed to emake install-doc install-mangit-subtree"
435 fi
436 newdoc README README.git-subtree
437 dodoc git-subtree.txt
438 cd "${S}"
439
440 # git-diffall
441 dobin contrib/diffall/git-diffall
442 newdoc contrib/diffall/README git-diffall.txt
443
444 # diff-highlight
445 dobin contrib/diff-highlight/diff-highlight
446 newdoc contrib/diff-highlight/README README.diff-highlight
447
448 # git-jump
449 exeinto /usr/libexec/git-core/
450 doexe contrib/git-jump/git-jump
451 newdoc contrib/git-jump/README git-jump.txt
452
453 # git-contacts
454 exeinto /usr/libexec/git-core/
455 doexe contrib/contacts/git-contacts
456 dodoc contrib/contacts/git-contacts.txt
457
458 if use gnome-keyring ; then
459 cd "${S}"/contrib/credential/gnome-keyring
460 dobin git-credential-gnome-keyring
461 fi
462
463 if use subversion ; then
464 cd "${S}"/contrib/svn-fe
465 dobin svn-fe
466 dodoc svn-fe.txt
467 use doc && doman svn-fe.1 && dohtml svn-fe.html
468 cd "${S}"
469 fi
470
471 # remote-helpers
472 if use python ; then
473 python_scriptinto /usr/libexec/git-core/
474 python_doscript "${S}"/contrib/remote-helpers/git-remote-{bzr,hg}
475 python_optimize
476 fi
477
478 dodir /usr/share/${PN}/contrib
479 # The following are excluded:
480 # completion - installed above
481 # credential/gnome-keyring TODO
482 # diff-highlight - done above
483 # diffall - done above
484 # emacs - installed above
485 # examples - these are stuff that is not used in Git anymore actually
486 # git-jump - done above
487 # gitview - installed above
488 # p4import - excluded because fast-import has a better one
489 # patches - stuff the Git guys made to go upstream to other places
490 # persistent-https - TODO
491 # mw-to-git - TODO
492 # subtree - build seperately
493 # svnimport - use git-svn
494 # thunderbird-patch-inline - fixes thunderbird
495 for i in \
496 buildsystems ciabot convert-objects fast-import \
497 hg-to-git hooks remotes2config.sh rerere-train.sh \
498 stats vim workdir \
499 ; do
500 cp -rf \
501 "${S}"/contrib/${i} \
502 "${ED}"/usr/share/${PN}/contrib \
503 || die "Failed contrib ${i}"
504 done
505
506 if use perl && use cgi ; then
507 # We used to install in /usr/share/${PN}/gitweb
508 # but upstream installs in /usr/share/gitweb
509 # so we will install a symlink and use their location for compat with other
510 # distros
511 dosym /usr/share/gitweb /usr/share/${PN}/gitweb
512
513 # INSTALL discusses configuration issues, not just installation
514 docinto /
515 newdoc "${S}"/gitweb/INSTALL INSTALL.gitweb
516 newdoc "${S}"/gitweb/README README.gitweb
517
518 find "${ED}"/usr/lib64/perl5/ \
519 -name .packlist \
520 -exec rm \{\} \;
521 else
522 rm -rf "${ED}"/usr/share/gitweb
523 fi
524
525 if ! use subversion ; then
526 rm -f "${ED}"/usr/libexec/git-core/git-svn \
527 "${ED}"/usr/share/man/man1/git-svn.1*
528 fi
529
530 if use xinetd ; then
531 insinto /etc/xinetd.d
532 newins "${FILESDIR}"/git-daemon.xinetd git-daemon
533 fi
534
535 if use !prefix ; then
536 newinitd "${FILESDIR}"/git-daemon.initd git-daemon
537 newconfd "${FILESDIR}"/git-daemon.confd git-daemon
538 systemd_newunit "${FILESDIR}/git-daemon_at.service" "git-daemon@.service"
539 systemd_dounit "${FILESDIR}/git-daemon.socket"
540 fi
541
542 fixlocalpod
543 }
544
545 src_test() {
546 local disabled=""
547 local tests_cvs="t9200-git-cvsexportcommit.sh \
548 t9400-git-cvsserver-server.sh \
549 t9401-git-cvsserver-crlf.sh \
550 t9600-cvsimport.sh \
551 t9601-cvsimport-vendor-branch.sh \
552 t9602-cvsimport-branches-tags.sh \
553 t9603-cvsimport-patchsets.sh"
554 local tests_perl="t3701-add-interactive.sh \
555 t5502-quickfetch.sh \
556 t5512-ls-remote.sh \
557 t5520-pull.sh \
558 t7106-reset-unborn-branch.sh \
559 t7501-commit.sh"
560 # Bug #225601 - t0004 is not suitable for root perm
561 # Bug #219839 - t1004 is not suitable for root perm
562 # t0001-init.sh - check for init notices EPERM* fails
563 local tests_nonroot="t0001-init.sh \
564 t0004-unwritable.sh \
565 t0070-fundamental.sh \
566 t1004-read-tree-m-u-wf.sh \
567 t3700-add.sh \
568 t7300-clean.sh"
569 # t9100 still fails with symlinks in SVN 1.7
570 local test_svn="t9100-git-svn-basic.sh"
571
572 # Unzip is used only for the testcase code, not by any normal parts of Git.
573 if ! has_version app-arch/unzip ; then
574 einfo "Disabling tar-tree tests"
575 disabled="${disabled} t5000-tar-tree.sh"
576 fi
577
578 cvs=0
579 use cvs && let cvs=$cvs+1
580 if [[ ${EUID} -eq 0 ]]; then
581 if [[ $cvs -eq 1 ]]; then
582 ewarn "Skipping CVS tests because CVS does not work as root!"
583 ewarn "You should retest with FEATURES=userpriv!"
584 disabled="${disabled} ${tests_cvs}"
585 fi
586 einfo "Skipping other tests that require being non-root"
587 disabled="${disabled} ${tests_nonroot}"
588 else
589 [[ $cvs -gt 0 ]] && \
590 has_version dev-vcs/cvs && \
591 let cvs=$cvs+1
592 [[ $cvs -gt 1 ]] && \
593 has_version "dev-vcs/cvs[server]" && \
594 let cvs=$cvs+1
595 if [[ $cvs -lt 3 ]]; then
596 einfo "Disabling CVS tests (needs dev-vcs/cvs[USE=server])"
597 disabled="${disabled} ${tests_cvs}"
598 fi
599 fi
600
601 if ! use perl ; then
602 einfo "Disabling tests that need Perl"
603 disabled="${disabled} ${tests_perl}"
604 fi
605
606 einfo "Disabling tests that fail with SVN 1.7"
607 disabled="${disabled} ${test_svn}"
608
609 # Reset all previously disabled tests
610 cd "${S}/t"
611 for i in *.sh.DISABLED ; do
612 [[ -f "${i}" ]] && mv -f "${i}" "${i%.DISABLED}"
613 done
614 einfo "Disabled tests:"
615 for i in ${disabled} ; do
616 [[ -f "${i}" ]] && mv -f "${i}" "${i}.DISABLED" && einfo "Disabled $i"
617 done
618
619 # Avoid the test system removing the results because we want them ourselves
620 sed -e '/^[[:space:]]*$(MAKE) clean/s,^,#,g' \
621 -i "${S}"/t/Makefile
622
623 # Clean old results first, must always run
624 cd "${S}/t"
625 nonfatal git_emake clean
626
627 # Now run the tests, keep going if we hit an error, and don't terminate on
628 # failure
629 cd "${S}"
630 einfo "Start test run"
631 #MAKEOPTS=-j1
632 nonfatal git_emake --keep-going test
633 rc=$?
634
635 # Display nice results, now print the results
636 cd "${S}/t"
637 nonfatal git_emake aggregate-results
638
639 # And bail if there was a problem
640 [ $rc -eq 0 ] || die "tests failed. Please file a bug."
641 }
642
643 showpkgdeps() {
644 local pkg=$1
645 shift
646 elog " $(printf "%-17s:" ${pkg}) ${@}"
647 }
648
649 pkg_postinst() {
650 use emacs && elisp-site-regen
651 einfo "Please read /usr/share/bash-completion/git for Git bash command completion"
652 einfo "Please read /usr/share/bash-completion/git-prompt for Git bash prompt"
653 einfo "Note that the prompt bash code is now in the seperate script"
654 elog "These additional scripts need some dependencies:"
655 echo
656 showpkgdeps git-quiltimport "dev-util/quilt"
657 showpkgdeps git-instaweb \
658 "|| ( www-servers/lighttpd www-servers/apache )"
659 echo
660 }
661
662 pkg_postrm() {
663 use emacs && elisp-site-regen
664 }